Loading...
Searching...
No Matches
TrcPktDecodeEtmV4I Class Reference

`#include <trc_pkt_decode_etmv4i.h>`

Inheritance diagram for TrcPktDecodeEtmV4I:
[legend]
Collaboration diagram for TrcPktDecodeEtmV4I:
[legend]

## Public Member Functions

| TrcPktDecodeEtmV4I ()
| TrcPktDecodeEtmV4I (int instIDNum)
virtual | ~TrcPktDecodeEtmV4I ()
Public Member Functions inherited from TrcPktDecodeBase< EtmV4ITrcPacket, EtmV4Config >
| TrcPktDecodeBase (const char *component_name)
| TrcPktDecodeBase (const char *component_name, int instIDNum)
virtual | ~TrcPktDecodeBase ()
virtual ocsd_datapath_resp_t | PacketDataIn (const ocsd_datapath_op_t op, const ocsd_trc_index_t index_sop, const EtmV4ITrcPacket *p_packet_in)
ocsd_err_t | setProtocolConfig (const EtmV4Config *config)
const EtmV4Config * | getProtocolConfig () const
Public Member Functions inherited from TrcPktDecodeI
| TrcPktDecodeI (const char *component_name)
| TrcPktDecodeI (const char *component_name, int instIDNum)
virtual | ~TrcPktDecodeI ()
componentAttachPt< ITrcGenElemIn > * | getTraceElemOutAttachPt ()
componentAttachPt< ITargetMemAccess > * | getMemoryAccessAttachPt ()
componentAttachPt< IInstrDecode > * | getInstrDecodeAttachPt ()
void | setUsesMemAccess (bool bUsesMemaccess)
const bool | getUsesMemAccess () const
void | setUsesIDecode (bool bUsesIDecode)
const bool | getUsesIDecode () const
Public Member Functions inherited from TraceComponent
| TraceComponent (const std::string &name)
| TraceComponent (const std::string &name, int instIDNum)
virtual | ~TraceComponent ()
const std::string & | getComponentName () const
void | setComponentName (const std::string &name)
componentAttachPt< ITraceErrorLog > * | getErrorLogAttachPt ()
ocsd_err_t | setComponentOpMode (uint32_t op_flags)
const uint32_t | getComponentOpMode () const
const uint32_t | getSupportedOpModes () const
void | setAssocComponent (TraceComponent *assocComp)
TraceComponent * | getAssocComponent ()
void | LogDefMessage (const std::string &msg)
Public Member Functions inherited from IPktDataIn< P >
| IPktDataIn ()
virtual | ~IPktDataIn ()
Public Member Functions inherited from ITrcTypedBase
| ITrcTypedBase ()
virtual | ~ITrcTypedBase ()

## Protected Member Functions

virtual ocsd_datapath_resp_t | processPacket ()
virtual ocsd_datapath_resp_t | onEOT ()
virtual ocsd_datapath_resp_t | onReset ()
virtual ocsd_datapath_resp_t | onFlush ()
virtual ocsd_err_t | onProtocolConfig ()
virtual const uint8_t | getCoreSightTraceID ()
void | initDecoder ()
void | resetDecoder ()
virtual void | onFirstInitOK ()
ocsd_err_t | decodePacket ()
ocsd_datapath_resp_t | resolveElements ()
ocsd_err_t | commitElements ()
ocsd_err_t | commitElemOnEOT ()
ocsd_err_t | cancelElements ()
ocsd_err_t | mispredictAtom ()
ocsd_err_t | discardElements ()
void | doTraceInfoPacket ()
void | updateContext (TrcStackElemCtxt *pCtxtElem, OcsdTraceElement &elem)
ocsd_err_t | processAtom (const ocsd_atm_val atom)
ocsd_err_t | processException ()
ocsd_err_t | processQElement ()
ocsd_err_t | processSourceAddress ()
ocsd_err_t | processTS_CC_EventElem (TrcStackElem *pElem)
ocsd_err_t | processMarkerElem (TrcStackElem *pElem)
ocsd_err_t | processTransElem (TrcStackElem *pElem)
ocsd_err_t | processITEElem (TrcStackElem *pElem)
ocsd_err_t | handleBadPacket (const char *reason, ocsd_trc_index_t index=OCSD_BAD_TRC_INDEX)
ocsd_err_t | handlePacketSeqErr (ocsd_err_t err, ocsd_trc_index_t index, const char *reason)
ocsd_err_t | handleBadImageError (ocsd_trc_index_t index, const char *reason)
ocsd_err_t | handlePacketErr (ocsd_err_t err, ocsd_err_severity_t sev, ocsd_trc_index_t index, const char *reason, const unsync_info_t unsync_reason)
ocsd_err_t | addElemCC (TrcStackElemParam *pParamElem)
ocsd_err_t | addElemTS (TrcStackElemParam *pParamElem, bool withCC)
ocsd_err_t | addElemEvent (TrcStackElemParam *pParamElem)
Protected Member Functions inherited from TrcPktDecodeBase< EtmV4ITrcPacket, EtmV4Config >
void | ClearConfigObj ()
Protected Member Functions inherited from TrcPktDecodeI
const bool | checkInit ()
ocsd_datapath_resp_t | outputTraceElement (const OcsdTraceElement &elem)
ocsd_datapath_resp_t | outputTraceElementIdx (ocsd_trc_index_t idx, const OcsdTraceElement &elem)
ocsd_err_t | accessMemory (const ocsd_vaddr_t address, const ocsd_mem_space_acc_t mem_space, uint32_t *num_bytes, uint8_t *p_buffer)
ocsd_err_t | invalidateMemAccCache ()
ocsd_err_t | instrDecode (ocsd_instr_info *instr_info)
Protected Member Functions inherited from TraceComponent
void | LogError (const ocsdError &Error)
void | LogMessage (const ocsd_err_severity_t filter_level, const std::string &msg)
const ocsd_err_severity_t | getErrorLogLevel () const
const bool | isLoggingErrorLevel (const ocsd_err_severity_t level) const
void | updateErrorLogLevel ()
void | do_attach_notify (const int num_attached)
void | Init (const std::string &name)

## Additional Inherited Members

Protected Attributes inherited from TrcPktDecodeBase< EtmV4ITrcPacket, EtmV4Config >
EtmV4Config * | m_config
const EtmV4ITrcPacket * | m_curr_packet_in
Protected Attributes inherited from TrcPktDecodeI
componentAttachPt< ITrcGenElemIn > | m_trace_elem_out
componentAttachPt< ITargetMemAccess > | m_mem_access
componentAttachPt< IInstrDecode > | m_instr_decode
ocsd_trc_index_t | m_index_curr_pkt
bool | m_decode_init_ok
| set true if all attachments in place for decode. (remove checks in main throughput paths)
bool | m_config_init_ok
| set true if config set.
std::string | init_err_msg
| error message for init error
bool | m_uses_memaccess
bool | m_uses_idecode
Protected Attributes inherited from TraceComponent
uint32_t | m_op_flags
| current component operational mode flags.
uint32_t | m_supported_op_flags
| supported component operational mode flags - derived class to intialise.

## Detailed Description

Definition at line 52 of file trc_pkt_decode_etmv4i.h.

## Constructor & Destructor Documentation

## TrcPktDecodeEtmV4I() [1/2]

TrcPktDecodeEtmV4I::TrcPktDecodeEtmV4I | ( |  | ) |

## TrcPktDecodeEtmV4I() [2/2]

TrcPktDecodeEtmV4I::TrcPktDecodeEtmV4I | ( | int | instIDNum | ) |

## ~TrcPktDecodeEtmV4I()

virtual TrcPktDecodeEtmV4I::~TrcPktDecodeEtmV4I | ( |  | ) |

virtual

## Member Function Documentation

## addElemCC()

ocsd_err_t TrcPktDecodeEtmV4I::addElemCC | ( | TrcStackElemParam * | pParamElem | ) |

protected

## addElemEvent()

ocsd_err_t TrcPktDecodeEtmV4I::addElemEvent | ( | TrcStackElemParam * | pParamElem | ) |

protected

## addElemTS()

ocsd_err_t TrcPktDecodeEtmV4I::addElemTS | ( | TrcStackElemParam * | pParamElem,
|  | bool | withCC
| ) |  |

protected

## cancelElements()

ocsd_err_t TrcPktDecodeEtmV4I::cancelElements | ( |  | ) |

protected

## commitElements()

ocsd_err_t TrcPktDecodeEtmV4I::commitElements | ( |  | ) |

protected

## commitElemOnEOT()

ocsd_err_t TrcPktDecodeEtmV4I::commitElemOnEOT | ( |  | ) |

protected

## decodePacket()

ocsd_err_t TrcPktDecodeEtmV4I::decodePacket | ( |  | ) |

protected

## discardElements()

ocsd_err_t TrcPktDecodeEtmV4I::discardElements | ( |  | ) |

protected

## doTraceInfoPacket()

void TrcPktDecodeEtmV4I::doTraceInfoPacket | ( |  | ) |

protected

## getCoreSightTraceID()

virtual const uint8_t TrcPktDecodeEtmV4I::getCoreSightTraceID | ( |  | ) |

inline protected virtual

Implements TrcPktDecodeI.

Definition at line 66 of file trc_pkt_decode_etmv4i.h.

## handleBadImageError()

ocsd_err_t TrcPktDecodeEtmV4I::handleBadImageError | ( | ocsd_trc_index_t | index,
|  | const char * | reason
| ) |  |

protected

## handleBadPacket()

ocsd_err_t TrcPktDecodeEtmV4I::handleBadPacket | ( | const char * | reason,
|  | ocsd_trc_index_t | index = `OCSD_BAD_TRC_INDEX`
| ) |  |

protected

## handlePacketErr()

ocsd_err_t TrcPktDecodeEtmV4I::handlePacketErr | ( | ocsd_err_t | err,
|  | ocsd_err_severity_t | sev,
|  | ocsd_trc_index_t | index,
|  | const char * | reason,
|  | const unsync_info_t | unsync_reason
| ) |  |

protected

## handlePacketSeqErr()

ocsd_err_t TrcPktDecodeEtmV4I::handlePacketSeqErr | ( | ocsd_err_t | err,
|  | ocsd_trc_index_t | index,
|  | const char * | reason
| ) |  |

protected

## initDecoder()

void TrcPktDecodeEtmV4I::initDecoder | ( |  | ) |

protected

## mispredictAtom()

ocsd_err_t TrcPktDecodeEtmV4I::mispredictAtom | ( |  | ) |

protected

## onEOT()

virtual ocsd_datapath_resp_t TrcPktDecodeEtmV4I::onEOT | ( |  | ) |

protected virtual

Implements TrcPktDecodeI.

## onFirstInitOK()

virtual void TrcPktDecodeEtmV4I::onFirstInitOK | ( |  | ) |

protected virtual

Reimplemented from TrcPktDecodeI.

## onFlush()

virtual ocsd_datapath_resp_t TrcPktDecodeEtmV4I::onFlush | ( |  | ) |

protected virtual

Implements TrcPktDecodeI.

## onProtocolConfig()

virtual ocsd_err_t TrcPktDecodeEtmV4I::onProtocolConfig | ( |  | ) |

protected virtual

Implements TrcPktDecodeI.

## onReset()

virtual ocsd_datapath_resp_t TrcPktDecodeEtmV4I::onReset | ( |  | ) |

protected virtual

Implements TrcPktDecodeI.

## processAtom()

ocsd_err_t TrcPktDecodeEtmV4I::processAtom | ( | const ocsd_atm_val | atom | ) |

protected

## processException()

ocsd_err_t TrcPktDecodeEtmV4I::processException | ( |  | ) |

protected

## processITEElem()

ocsd_err_t TrcPktDecodeEtmV4I::processITEElem | ( | TrcStackElem * | pElem | ) |

protected

## processMarkerElem()

ocsd_err_t TrcPktDecodeEtmV4I::processMarkerElem | ( | TrcStackElem * | pElem | ) |

protected

## processPacket()

virtual ocsd_datapath_resp_t TrcPktDecodeEtmV4I::processPacket | ( |  | ) |

protected virtual

Implements TrcPktDecodeI.

## processQElement()

ocsd_err_t TrcPktDecodeEtmV4I::processQElement | ( |  | ) |

protected

## processSourceAddress()

ocsd_err_t TrcPktDecodeEtmV4I::processSourceAddress | ( |  | ) |

protected

## processTransElem()

ocsd_err_t TrcPktDecodeEtmV4I::processTransElem | ( | TrcStackElem * | pElem | ) |

protected

## processTS_CC_EventElem()

ocsd_err_t TrcPktDecodeEtmV4I::processTS_CC_EventElem | ( | TrcStackElem * | pElem | ) |

protected

## resetDecoder()

void TrcPktDecodeEtmV4I::resetDecoder | ( |  | ) |

protected

## resolveElements()

ocsd_datapath_resp_t TrcPktDecodeEtmV4I::resolveElements | ( |  | ) |

protected

## updateContext()

void TrcPktDecodeEtmV4I::updateContext | ( | TrcStackElemCtxt * | pCtxtElem,
|  | OcsdTraceElement & | elem
| ) |  |

protected

## Member Data Documentation

## discard

bool TrcPktDecodeEtmV4I::discard

discard elements

Definition at line 228 of file trc_pkt_decode_etmv4i.h.

## mispredict

bool TrcPktDecodeEtmV4I::mispredict

mispredict latest atom

Definition at line 227 of file trc_pkt_decode_etmv4i.h.

## next_st_addr

ocsd_vaddr_t TrcPktDecodeEtmV4I::next_st_addr

Definition at line 259 of file trc_pkt_decode_etmv4i.h.

## P0_cancel

int TrcPktDecodeEtmV4I::P0_cancel

elements to cancel

Definition at line 226 of file trc_pkt_decode_etmv4i.h.

## P0_commit

int TrcPktDecodeEtmV4I::P0_commit

number of elements to commit

Definition at line 225 of file trc_pkt_decode_etmv4i.h.

## valid

bool TrcPktDecodeEtmV4I::valid

Definition at line 260 of file trc_pkt_decode_etmv4i.h.

The documentation for this class was generated from the following file:

- /build/libopencsd-8WV101/libopencsd-1.5.5/decoder/include/opencsd/etmv4/trc_pkt_decode_etmv4i.h